package io.skore.smooch_plugin

import android.app.Activity
import android.app.Application
import android.os.Bundle
import android.util.Log
import com.google.firebase.FirebaseApp
import io.flutter.view.FlutterMain
import io.skore.smooch_plugin.view.ChatActivity
import io.smooch.core.Smooch

class PluginApplication : Application(), Application.ActivityLifecycleCallbacks {
    private val tag = PluginApplication::class.java.simpleName
    private var mCurrentActivity: Activity? = null

    companion object {
        var isChatbotResumed = false
    }

    override fun onCreate() {
        super.onCreate()
        Log.d(tag, "onCreate")

        registerActivityLifecycleCallbacks(this)
        FlutterMain.startInitialization(this)
        FirebaseApp.initializeApp(this)
        Smooch.init(this)
    }

    fun getCurrentActivity(): Activity? {
        return this.mCurrentActivity
    }

    fun setCurrentActivity(currentActivity: Activity) {
        mCurrentActivity = currentActivity
    }

    override fun onActivityPaused(activity: Activity?) {
        if (activity?.javaClass?.simpleName == ChatActivity::class.java.simpleName) {
            Log.d(tag, "isChatbotResumed = false")
            isChatbotResumed = false
        }
    }

    override fun onActivityResumed(activity: Activity?) {
        if (activity?.javaClass?.simpleName == ChatActivity::class.java.simpleName) {
            Log.d(tag, "isChatbotResumed = true")
            isChatbotResumed = true
        }
    }

    override fun onActivityStarted(activity: Activity?) {

    }

    override fun onActivityDestroyed(activity: Activity?) {

    }

    override fun onActivitySaveInstanceState(activity: Activity?, outState: Bundle?) {

    }

    override fun onActivityStopped(activity: Activity?) {

    }

    override fun onActivityCreated(activity: Activity?, savedInstanceState: Bundle?) {

    }
}